<?php
/**
 * Cashenvoy Plugin For Oscommerce v2.3.3
 *
 * @author Oluwatomi Alagbe, August 2013
 *
 * (place in oscommerce/includes/modules/payment/)
 */

if(!defined('MODULE_PAYMENT_CASHENVOY_TABLE'))
    define('MODULE_PAYMENT_CASHENVOY_TABLE', 'cashenvoy');
	
class cashenvoy
{
	var $code, $title, $description, $enabled, $merchant_id, $transref;
	
	function cashenvoy()
	{
		global $order;
		
		/**
		$this->signature = 'paypal|paypal_express|1.2|2.2';
		$this->api_version = '60.0';
		*/
		$this->signature = 'cashenvoy|cashenvoy|1.0|1.0';
		$this->api_version = '1.2';
		
		$this->code = 'cashenvoy';
		$this->title = MODULE_PAYMENT_CASHENVOY_TEXT_TITLE;
		$this->public_title = MODULE_PAYMENT_CASHENVOY_TEXT_PUBLIC_TITLE;
		$this->description = MODULE_PAYMENT_CASHENVOY_TEXT_DESCRIPTION;
		$this->sort_order = MODULE_PAYMENT_CASHENVOY_SORT_ORDER;
		$this->enabled = ((MODULE_PAYMENT_CASHENVOY_STATUS == 'True') ? true : false);
		
		if ((int)MODULE_PAYMENT_CASHENVOY_ORDER_STATUS_ID > 0)
		{
			$this->order_status = MODULE_PAYMENT_CASHENVOY_ORDER_STATUS_ID;
		}
		
		if (is_object($order)) $this->update_status();
		
		if (MODULE_PAYMENT_CASHENVOY_TRANSACTION_MODE == 'Sandbox')
		{
			$this->form_action_url = 'https://www.cashenvoy.com/sandbox/?cmd=cepay';
			$this->is_live = false;
		}
		else
		{
			$this->form_action_url = 'https://www.cashenvoy.com/webservice/?cmd=cepay';
			$this->is_live = true;
		}
	}
	
	function update_status()
	{
		global $order;
		
		if (($this->enabled == true) && ((int)MODULE_PAYMENT_CASHENVOY_ZONE > 0))
		{
			$check_flag = false;
			$check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_CASHENVOY_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
			
			while ($check = tep_db_fetch_array($check_query)) 
			{
				if ($check['zone_id'] < 1) 
				{
					$check_flag = true;
					break;
				}
				elseif ($check['zone_id'] == $order->billing['zone_id']) 
				{
					$check_flag = true;
					break;
				}
			}
			
			if ($check_flag == false)
			{
				$this->enabled = false;
			}
		}
	}	
	
	function javascript_validation() 
	{
		return false;
        }
	
	function selection() 
	{
      return array('id' => $this->code,
                   'module' => $this->public_title);
    }
	
	function pre_confirmation_check() 
	{
		return false;
    }
	
	function confirmation()
	{
	}
	
	function generate_random_string($field, $max_length = 15)
	{
		$string = '';
		for ($i = 0; $i < $max_length; $i++)
		{
			$index = mt_rand(0, strlen($field) - 1);
			$string .= $field[$index];
		}
		
		return $string;
	}		
	
	function process_button()
	{
		global $HTTP_SERVER_VARS, $order, $merchant_id, $transref;
		//print_r($order);
		
		$merchant_id = MODULE_PAYMENT_CASHENVOY_MERCHANT_ID;
		//$this->merchant_id = MODULE_PAYMENT_CASHENVOY_MERCHANT_ID;
		//echo "MERCHANT ID: {$this->merchant_id}<br />";
		
		$amount = (double)$order->info['total'];
		$amount = (double)$amount;
		$_SESSION['ce_amt'] = $amount;
		//echo "AMOUNT: {$amount}<br />";
		
		$customer_name = $order->customer['firstname'] . $order->customer['lastname'];
		//echo "CUSTOMER NAME: {$customer_name}<br />";
		
		$customer_id = $order->customer['email_address'];
		//echo "CUSTOMER EMAIL: {$customer_id}<br />";
		
		$field = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890";
		$transref = $this->generate_random_string($field, 15);
		$_SESSION['transref'] = $transref;
		//echo "TRANSACTION REFERENCE: {$this->transref}<br />";
		
		$product_description = "";		
		//loop through all products		
		$products = $order->products;
		for ($i = 0; $i < count($products); $i++)
			$product_description .= "Purchase of {$products[$i]['name']}. Quantity: {$products[$i]['qty']}<br />";
		//echo "PRODUCT DESCCRIPTION: {$product_description}<br />";
		
		$notify_url = tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL', true);		
		$notify_url2 = tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code, 'NONSSL', true);
		//echo "NOTIFY URLS: " . $notify_url . "<br />" . $notify_url2 . "<br />";
		
		$process_button_string = tep_draw_hidden_field('ce_merchantid', $merchant_id) . 
							tep_draw_hidden_field('ce_transref', $transref) . 
							tep_draw_hidden_field('ce_amount', $amount) . 
							tep_draw_hidden_field('ce_customerid', $customer_id) . 
							tep_draw_hidden_field('ce_memo', $product_description) . 
							tep_draw_hidden_field('ce_notifyurl', $notify_url) . 
							tep_draw_hidden_field('ce_window', 'parent');
		tep_db_query("insert into " . MODULE_PAYMENT_CASHENVOY_TABLE . " set transref='$transref', description='$product_description', customer_id='$customer_id', amount=$amount, status='fail', date=NOW()");
		$_SESSION['curr_trans_id'] = mysql_insert_id();
		
		return $process_button_string;
	}
	
	function getStatus($transref,$mertid,$type='')
	{			
		//$request = 'mertid='.$mertid.'&transref='.$transref.'&respformat='.$type; //initialize the request variables
		$request = 'mertid=5&transref='.$transref.'&respformat='.$type; //initialize the request variables
		//echo 'getStatus query:' . $request;
		if ($this->is_live == false)
			$url = 'https://www.cashenvoy.com/sandbox/?cmd=requery'; //this is the url of the gateway's test api
		else
			$url = 'http://www.cashenvoy.com/webservice/?cmd=requery';
		//$url = 'http://localhost/cashenvoy/webservice/?cmd=requery'; //this is the url of the gateway's live api
		$ch = curl_init(); //initialize curl handle
		curl_setopt($ch, CURLOPT_URL, $url); //set the url
		curl_setopt($ch, CURLOPT_RETURNTRANSFER,true); //return as a variable
		curl_setopt($ch, CURLOPT_POST, 1); //set POST method
		curl_setopt($ch, CURLOPT_POSTFIELDS, $request); //set the POST variables
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		$response = curl_exec($ch); // grab URL and pass it to the browser. Run the whole process and return the response
		curl_close($ch); //close the curl handle
		return $response;	
	}
	
	function before_process()
	{
		global $HTTP_POST_VARS, $cart, $order;
		
		if (isset($_SESSION['transref']))
		{
			$transref = $_SESSION['transref'];
		}		
		$response = $response = $this->getStatus($transref, MODULE_PAYMENT_CASHENVOY_MERCHANT_ID, 'json');
		
		/////////////////////////		
		//print_r($response);
		/////////////////////////
		
		$data = json_decode($response, TRUE);
		// parse the response
		/////////////////////////
		//print_r($data);
		/////////////////////////
		if (!is_array($data) || count($data) < 3)
		{
			tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode('No payment information found.'),'NONSSL',true,false));
		}
		
		// read data returned from gateway
		$returned_transref = $data['TransactionId'];
		$returned_status = $data['TransactionStatus'];
		$returned_amount = $data['TransactionAmount'];
		
		//echo "status: {$returned_status} <br /> Amount: {$returned_amount} <br /> Amount == Session: " . $returned_amount == $_SESSION['ce_amt'];
		// setup mail sending parameters
		$mail_to = $order->customer['email_address'];
		$subject = 'Cashenvoy Opencart Payment';
		$mail_message = '';
		$headers = 'From: Cashenvoy <support@cashenvoy.com>' . '\r\n';
		$headers .= "MIME-Version: 1.0\r\n";
		$headers .= "Content-Type: text/html; charset=ISO-8859-1\r\n";		
		
		if ($returned_status == 'C00')
		{
   		   /* echo 'returned: ' . $returned_amount . '<br />session data: ' . $_SESSION['ce_amt'] . '</br />' . 'returned == session:' . $returned_acount == $_SESSION['ce_amt'];*/
		    if ($returned_amount != (double)$_SESSION['ce_amt'])
		    {
		          tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode('Data has been tampered! Payment aborted.'),'NONSSL',true, false));
		    }
		    else
		    {
		    	$id = $_SESSION['curr_trans_id'];
			tep_db_query("UPDATE " . MODULE_PAYMENT_CASHENVOY_TABLE . " SET status='success' where cashenvoy_id=" . $id);
		    }								    
			$mail_message = '<html><body>';
			//$mail_message .= '<h4>Payment Status</h4>';
			$mail_message .= '<p><strong>Your payment was successful</strong></p>';
			$mail_message .= '<p><strong>Transaction Reference:</strong><br />';
			$mail_message .= '-----------------------<br />';
			$mail_message .= $returned_transref;
			$mail_message .= '<br /><strong>Amount</strong><br />';
			$mail_message .= '-----------------------<br />';
			$mail_message .= $returned_amount;
			$mail_message .= '</p>';
			$mail_message .= '</body></html>';
			// send message
			mail($mail_to, $subject, $mail_message, $headers);
		}
		else
		{
		    switch ($returned_status)
		    {
		        case 'C01':
		            $message = 'Transaction Failed. You cancelled this transaction.';		            
		            $fail_reason = 'Transaction cancelled';
		            break;
		        case 'C02':
		            $message = 'Transaction Failed. Server Timeout.';
		            $fail_reason = 'User inactivity';
		            break;
		        case 'C03':
		            $message = 'Transaction Failed. There is no record of this transaction.';
		            $fail_reason = 'No transaction record';
		            break;
		        case 'C04':
		            $message = 'Transaction Failed. You do not have sufficient funds to complete this transaction.';
		            $fail_reason = 'Insufficiient funds';
		            break;
		        case 'C05':
		            $message = 'Transaction Failed. Contact support@cashenvoy.com for more information';
		            $fail_reason  = 'Server Error. Contact support@cashenvoy.com for info';
		            break;
		    }		   
			//$mail_message .= '<h4>Payment Status</h4>';
			$mail_message .= '<p><strong>Your payment failed</strong><br />';
			$mail_message .= '<strong>Reason:</strong>: ' . $fail_reason . '<br />';
			$mail_message .= '<p><strong>Transaction Reference:</strong><br />';
			$mail_message .= '-----------------------<br />';
			$mail_message .= $returned_transref;
			$mail_message .= '<br /><strong>Amount</strong><br />';
			$mail_message .= '-----------------------<br />';
			$mail_message .= $returned_amount;
			$mail_message .= '</p>';
			$mail_message .= '</body></html>';

			// send message
			mail($mail_to, $subject, $mail_message, $headers);
		     
		    tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode($message),'NONSSL',true, false));
		}
	}
	
	function after_process()
	{
	    global $order;
	    //print_r($order);
	    return true;
	}
	
	function get_error() 
	{
		return false;
    }

    function check() 
	{
		if (!isset($this->_check)) 
		{
			$check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_CASHENVOY_STATUS'");
			$this->_check = tep_db_num_rows($check_query);
		}
		
		return $this->_check;
    }
	
	function install() 
	{		
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Cashenvoy Payment Module', 'MODULE_PAYMENT_CASHENVOY_STATUS', 'False', 'Do you want to enable payments via Cashenvoy?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant ID', 'MODULE_PAYMENT_CASHENVOY_MERCHANT_ID', '5', 'Your Merchant ID. You must set this value to a unique merchant ID.(Your email address is good enough.)', '6', '1', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Payment Mode', 'MODULE_PAYMENT_CASHENVOY_TRANSACTION_MODE', 'Sandbox', 'Transaction mode. While testing your site, leave this on \'Sandbox\'', '6', '2', 'tep_cfg_select_option(array(\'Sandbox\', \'Live\'), ', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_CASHENVOY_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '3', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_CASHENVOY_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
    }
	
	function remove()
	{
		tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");		
	}
	
	function keys() 
	{
		//return array('MODULE_PAYMENT_SAGE_PAY_DIRECT_STATUS', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_VENDOR_LOGIN_NAME', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_TRANSACTION_METHOD', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_VERIFY_WITH_CVC', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_TRANSACTION_SERVER', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_ZONE', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_ORDER_STATUS_ID', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_SORT_ORDER', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_CURL', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_ALLOW_VISA', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_ALLOW_MC', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_ALLOW_DELTA', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_ALLOW_SOLO', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_ALLOW_MAESTRO', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_ALLOW_UKE', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_ALLOW_AMEX', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_ALLOW_DC', 'MODULE_PAYMENT_SAGE_PAY_DIRECT_ALLOW_JCB');
		return array('MODULE_PAYMENT_CASHENVOY_STATUS', 'MODULE_PAYMENT_CASHENVOY_MERCHANT_ID', 'MODULE_PAYMENT_CASHENVOY_TRANSACTION_MODE', 'MODULE_PAYMENT_CASHENVOY_ORDER_STATUS_ID', 'MODULE_PAYMENT_CASHENVOY_SORT_ORDER');
    }
	
}